#! /usr/bin/env python3.3
"""Parse git-fast-import mark output."""


class Mark:

    """One parsed line returned by git-fast-import."""

    def __init__(self):
        """Initialize a Mark instance."""
        # When set, is set to int representation of mark number. Value will
        # be 1 or greater. The mark amy represent a changelist number.
        self.mark = None
        self.sha1 = None
        # The branch_id, not a Branch instance.
        self.branch = None

    @staticmethod
    def from_line(line):
        """Parse a marks line of output from git-fast-import."""
        parts = line.split(' ')
        result = Mark()
        result.mark = int(parts[0][1:])
        result.sha1 = parts[1].strip()
        result.branch = parts[2].strip() if len(parts) > 2 else None
        return result

    def __str__(self):
        """Return str version of this."""
        return "mark {}, sha1 '{}', branch '{}'".format(self.mark, self.sha1, self.branch)
